.mem 8
.index 8

.org $8000

fullblocks = $9000
lastblocklength = $9001
bitrate = $9002

blockon = $00
nu = $01
temp = $ff


RESET:
        cld
        cli

        lda #0
        sta blockon
        sta nu

        lda #$00
        sta $2000
        sta $2001

        brk

mainloop:
        lda nu
        cmp #0
        beq mainloop


        lda #0
        sta nu

        lda blockon
        and #1
        asl a
        asl a
        asl a
        asl a
        asl a
        asl a
        sta temp

        lda blockon
        cmp fullblocks
        beq lastblock

        lda #$3f
        sta $4011
        lda bitrate        ;Don't Loop, Playback at 22khz
        ora #$80
        sta $4010
        lda temp
        sta $4012
        lda #255                    ;This val * 16 = length of data
        sta $4013
        lda #$10
        sta $4015

        inc blockon

        jmp mainloop

lastblock:
        lda #$3f
        sta $4011
        lda bitrate        ;Don't Loop, Playback at 22khz
        sta $4010
        lda temp
        sta $4012
        lda lastblocklength        ;This val * 16 = length of data
        sta $4013
        lda #$10
        sta $4015

        jmp mainloop


NMI:
IRQ:

        inc nu

        lda blockon
        lsr a
        clc
        adc #1
        sta $4506

        rti


vectors:
        .DW     NMI
        .DW     RESET
        .DW     IRQ
